'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slateDevLogger = require('slate-dev-logger');

var _slateDevLogger2 = _interopRequireDefault(_slateDevLogger);

var _value = require('../models/value');

var _value2 = _interopRequireDefault(_value);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Changes.
 *
 * @type {Object}
 */

var Changes = {};

/**
 * Set `properties` on the value.
 *
 * @param {Change} change
 * @param {Object|Value} properties
 */

Changes.setValue = function (change, properties) {
  properties = _value2.default.createProperties(properties);
  var value = change.value;


  change.applyOperation({
    type: 'set_value',
    properties: properties,
    value: value
  });
};

/**
 * Deprecated.
 */

Changes.setState = function (change) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  _slateDevLogger2.default.deprecate('0.29.0', 'The `change.setState` method has been renamed to `change.setValue`.');
  change.setValue.apply(change, args);
};

Changes.setData = function (change, data) {
  _slateDevLogger2.default.deprecate('0.26.0', 'The `change.setData` method is deprecated, use `change.setValue` instead.');
  change.setValue({ data: data });
};

/**
 * Export.
 *
 * @type {Object}
 */

exports.default = Changes;